system("clear");
if (-f "install.pl") {
  chdir("..");
}
$MAX     = 30;
chop($INSTALL_DIR = `pwd`);
$BIN_DIR = "$INSTALL_DIR/bin";
$LIB_DIR = "$INSTALL_DIR/lib";
print "install: locating perl\n";
chop($PERL = `which perl`);
unless (-f $PERL) { 
  print "install: perl not found\n";
  print "install: enter the complete path to perl --> ";
  chop($PERL = <STDIN>);
  unless (-f $PERL) {
    print "install: perl not found at $PERL\n";
    &abort
  }
} else {
  print "install: found perl at $PERL\n";
}

if (length($PERL) > $MAX) {
  print "install: path to perl is too long\n";
  print "install: creating symbolic link in current directory\n";
  chop($LINK = `pwd`); $LINK .= "/perl"; 
  if (&make_link($PERL, $LINK)) {
    print "install: symbolic link failed\n";
    do {} until(!&get_link);
  }
  $PERL = $LINK;
}

$version = `$PERL -v`; 
$version =~ /version (\S+)/;
$version = $1;

if ($version >= 5.0) {
  $VERSION_5 = 1;
} else {
  print "\n***You need Perl version 5 or greater.***\n";
  exit 0;
  $VERSION_5 = 0;
}

#
# System calls needed 
#

chop($GZIP     = `which gzip`);
chop($COMPRESS = `which uncompress`);
chop($CRONTAB  = `which crontab`);
chop($MAIL     = `which mail`);

unless (-x $GZIP) {
  print "install: ERROR: \"gzip\" is not in your PATH variable.\n";  
  exit 1;
}
unless (-x $COMPRESS) {
  print "install: ERROR: \"uncompress\" is not in your PATH variable.\n";  
  exit 1;
}
unless (-x $CRONTAB) {
  print "install: ERROR: \"crontab\" is not in your PATH variable.\n";
  exit 1;
}
unless (-x $MAIL) {
  print "install: ERROR: \"mail\" is not in your PATH variable.\n";
  exit 1;
}


&edit_file("bin/client");
&edit_file("bin/comms-daemon");
&edit_file("bin/comms-backup");
&edit_file("bin/disable-backup");


print "install: INSTALLATION COMPLETE\n\n";
print "********************************************************\n";
print "* Execute neos-comms to start the Communications Tool. *\n";
print "********************************************************\n\n";

system("ln -s ./bin/client neos-comms");


sub get_link {
  print "install: enter file to link $PERL to "; 
  do {
    print "--> "; &flush(STDOUT);
    chop($LINK = <STDIN>);
  } until ($LINK); 
  &make_link($PERL, $LINK);
}

sub edit_file {

  local ($DATA, $HANDLE, $file);
  $file = $_[0];
  #print "install: editing $file\n";
  $DATA = `cat $file` || die;

  #Remove old installation edit if it exists

  $DATA =~ s/^#!.*\n//;
  $DATA =~ s/#BEGIN AUTO EDIT(.*\n)*#END AUTO EDIT\n//g;

  #Write new stuff

  open (HANDLE, ">$file");
  print HANDLE "#!$PERL\n";
  print HANDLE "#BEGIN AUTO EDIT\n";
  print HANDLE "\$ENV{INSTALL_DIR} = \"$INSTALL_DIR\";\n";
  print HANDLE "\$ENV{BIN_DIR}     = \"$BIN_DIR\";\n";
  print HANDLE "\$ENV{LIB_DIR}     = \"$LIB_DIR\";\n";
  print HANDLE "\$ENV{TCL_LIBRARY} = \"$LIB_DIR/tcl7.4\";\n";
  print HANDLE "\$ENV{TK_LIBRARY}  = \"$LIB_DIR/tk4.0\";\n";
  print HANDLE "\$ENV{BITMAP}      = \"$LIB_DIR/icon.bmp\";\n";
  print HANDLE "\$ENV{PATH}        = \"$ENV{PATH}\";\n";
  if ($VERSION_5) {
    print HANDLE "use Socket;\n";
  } else {
    print HANDLE "require \"sys/socket.ph\";\n";
  }
  print HANDLE "#END AUTO EDIT\n";
  print HANDLE "$DATA";
  close (HANDLE);
}

sub abort {
  print "install: perl install failed\n";
  print "install: See client for installation instructions.\n"; 
  exit 1;
}

sub make_link {
  #path to perl is $_[0];
  #path to link is $_[1];
  unless ($_[1] =~ /^\//) {
    print "install: \"$_[1]\" is not an absolute path\n";
    return 1; 
  } 
  if (-d $_[1]) {
    print "install: \"$_[1]\" is a directory\n";
    return 1;
  }
  if (length($_[1]) > $MAX) {
    print "install: path to perl is too long\n";
    return 1;
  }
  print "install: linking $_[1] to $_[0]\n";
  system("ln -s $_[0] $_[1]");
}

sub flush {
    local($old) = select(shift);
    $| = 1;
    print "";
    $| = 0;
    select($old);
}
